#include "capwap_wtpconfiguration.h"
using namespace std;
using namespace Common;

namespace Gatekeeper {

WTPConfigurationListener::WTPConfigurationListener(
WTPTableInterface &pluginWTPTableInterfaceObject):
pwtpti(pluginWTPTableInterfaceObject)
{
}

SocketListener::SuggestedAction WTPConfigurationListener::failed (int socketID)
{
	cerr << "[CAPWAP] Socket " << socketID << " closed.\n";
	return (socketID == 1) ? STOP : DELETE;
}


CAPWAPMessage::MessageTypes WTPConfigurationListener::check(uint8_t *message, int size)
{
	CAPWAPMessage::MessageTypes type = CAPWAPMessage::NONE;
	bitset<1> cme; //Check message element
	CAPWAPMessage *m = reinterpret_cast<CAPWAPMessage*>(message);
	
	//Version Verify
	if(m->getVersion()!=0)
	{
		return type;
	}
	
	switch ( m->MessageType ) {
		case CAPWAPMessage::UPDATECONFIGURATION:
			type = CAPWAPMessage::UPDATECONFIGURATION;
			break;
		default:
			break;
	}
	return type;
}

SocketListener::SuggestedAction WTPConfigurationListener::receivedPacket (uint8_t *message, int size, int socketID,
								IPv4Address senderIP, uint16_t senderPort)
{
	CAPWAPMessage CP= *reinterpret_cast<CAPWAPMessage*>(message);
	//Check
	switch ( check(message,size) ) 
	{
		case CAPWAPMessage::UPDATECONFIGURATION:
			pwtpti.ConfigurationUpdate();
		break;
		
		default:
			break;
	}
	return CONTINUE;
}

}
