///
/// \file relay_listener.h
///	\author Albino Scalet
///
///	The file contains the definition of the interface between the StatusTable and the Report. 
///	The Report class derives from this class and implements the the pure virtual functions
///	that are defined here. The class is used by the Status Table to notify changes in the 
///	Status Table configuration to the Report (that will notify to the Gateway the new 
///	configuration of the IP addresses that are allowed to browse).
///
///	$Id: statustable_listener.h,v 1.1.1.1 2005/02/08 09:16:29 cvs Exp $
///

#ifndef _RELAY_LISTENER_
#define _RELAY_LISTENER_

#include <iostream>
#include "../Common/addresses.h"
#include "../Common/packets.h"
#include "../Common/socket.h"

using namespace std;
using namespace Common;

namespace Gatekeeper {

///
///	The file contains the definition of the interface between Relay Plugin and the Dispatcher. 
///	The class is used by the Relay Plugin to pass Server responses to the dispatcher for a correct forwarding.

class RelayListener{
private:

public:

	///
	/// The function provides an interface between Relay and Dispatcher	for DHCP responses.
	///
	virtual SocketListener::SuggestedAction sendResponseFrame(EthernetFrame* ethf, int size) =0;
						
};

}

#endif

