#ifndef UNIFY_FUNCS_H_
#define UNIFY_FUNCS_H_

#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h> 
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "../../dprint.h"
#include "../../ut.h"
#include "../../parser/contact/parse_contact.h"
#include "../../parser/msg_parser.h"
#include "../../parser/parse_to.h"
#include "../../parser/parse_from.h"
#include "../../mem/mem.h"

#define readline(fd, buf, l, x) \
		do{ static int _i;\
			for ((_i) = 0, *x = 0; (_i) < l; ++(_i)) { \
				if(readn(fd, buf+(_i), 1)){ \
					*x = -1; \
					break; \
				}else if(buf[(_i)] == '\n'){ \
					buf[(_i)] = '\0'; \
					*x = (_i) + 1; \
					break; \
				} \
			} \
		}while(0)
		
/*
 * Initialize the tcp connection with the authentication provider
 */
int init_tcp_conn(char *server, int port);
/*
 * 
 */
int writen(int fd, void* buf, size_t l);
/*
 * 
 */
int readn(int fd, void* buf, size_t l);
/*
 * 
 */
void close_tcp_conn(int scktfd);

#endif /*UNIFY_FUNCS_H_*/
