#ifndef SHM_FUNCS_H_
#define SHM_FUNCS_H_

#include <errno.h>
#include <string.h>
#include <sys/mman.h>
#include <unistd.h>
#include <fcntl.h>

#include "../../dprint.h"
#include "../../str.h"
#include "unify_macro.h"

/* shared memory compile */
#define shmcrt(shm_name, shmsz, mode) (shmcomp(shm_name, shmsz, O_CREAT|O_EXCL|O_RDWR, mode))
/* shared memory remove */
#define shmrmv(shm_name) (shm_unlink(shm_name))
/* get shared memory */
#define	getshm(shm_name, shmsz) (shmcomp(shm_name, shmsz, O_EXCL|O_RDWR, 0))

/**
 * user
 */
struct _unify_user_t{
	char token[MAX_TOKEN_LEN];	/* token */
	int token_len;				/* token length */
	time_t last;				/* last entry modification */
	time_t renew;				/* authentication renewal time */	
};
typedef struct _unify_user_t unify_user_t;
/**
 * unify shared memory
 */
struct _unify_shm_t{
	int semid;						/* semaphore identifier */
	unify_user_t users[MAX_USER];	/* users table */
};
typedef struct _unify_shm_t unify_shm_t;
/*
 * Shared memory compile function.
 * This function is used to either:
 * - create shared memory segment;
 * - get shared memory segment;
 */
void* shmcomp(char *shm_name, off_t shmsz, int flag, mode_t mode);

#endif /*SHM_FUNCS_H_*/
