<?php

/*
Copyright (C) 2004 NetMob Group, Universit di Trento, Italy


     http://netmob.unitn.it/


This file is part of the WilmaGate system, created as part
of the WILMA Project, sponsored by the Autonomous
Province of Trento and participated by ITC-irst, the University
of Trento and Alpikom Spa. More info at


     http://www.wilmaproject.org/


PERMISSION OF USING AND MODIFYING THE WILMAGATE SYSTEM IS GRANTED
FOR RESEARCH PURPOSES ONLY. Implementations that are not
oriented to research are prohibited unless explicitly authorized
by the NetMob research group.
Please direct all authorization requests to


     Roberto Battiti battiti@dit.unitn.it


Technical questions can be directed to


     Mauro Brunato brunato@dit.unitn.it
*/


$user_email = "";
$user_name = "";

function RADIUS_auth ($login, $password, $index)
{
	global $RADIUS_server, $RADIUS_port, $RADIUS_shared_secret, $RADIUS_welcome_id, $user_email, $user_name;
	$srv = radius_auth_open();
	$res = radius_add_server($srv, $RADIUS_server[$index], $RADIUS_port[$index], $RADIUS_shared_secret[$index], 3, 3)
		&& radius_create_request($srv, RADIUS_ACCESS_REQUEST)
		&& radius_put_string ($srv, RADIUS_USER_NAME, $login)
		&& radius_put_string ($srv, RADIUS_USER_PASSWORD, $password);
	if ( $res )
		$res = radius_send_request($srv);
	if ( $res === FALSE ) {
		echo "Errore RADIUS: \"" . radius_strerror($srv) . "\"\n</body>\n</html>\n";
		exit;
	}

	if ( $res == RADIUS_ACCESS_ACCEPT ) {
		while ( $a = radius_get_attr($srv) ) {
			echo $a["attr"] . "<p>\n";
			if ( is_array($a) && $a["attr"] == $RADIUS_welcome_id[$index] ) {
				$user_name = strtok ($a["data"], ";");
				$user_email = trim(strtok (""));
			}
		}
		return TRUE;
	}

	return FALSE;
}

function mySQL_auth ($login, $password, $index)
{
	global $mySQL_server,
		$mySQL_user,
		$mySQL_password,
		$mySQL_database,
		$mySQL_table,
		$mySQL_username_column,
		$mySQL_password_column,
		$mySQL_name_column,
		$mySQL_email_column,
		$mySQL_expiration_column,
		$user_email,
		$user_name;
	$db = mysql_connect($mySQL_server[$index], $mySQL_user[$index], $mySQL_password[$index]);
	if ( !$db ) {
		echo "Impossibile connettersi al database specificato.\n</body>\n</html>\n";
		exit;
	}
	mysql_select_db ($mySQL_database[$index], $db);
	$rq = "select * from $mySQL_table[$index] where $mySQL_username_column[$index]=\"$login\" "
				."and $mySQL_password_column[$index]=\"" . md5($password) . "\""
				.(($mySQL_expiration_column[$index]=="")?""
					:(" and (" . $mySQL_expiration_column[$index] . " = \"0000-00-00\" or "
							. $mySQL_expiration_column[$index] . " >= \"" . date("Y-m-d") . "\")"));
	$res=mysql_query ($rq, $db);
	if ( !$res ) {
		echo "Errore nell'interrogazione.\n</body>\n</html>\n";
		exit;
	}

	if ( mysql_num_rows($res) > 0 ) {
		$row = mysql_fetch_array ($res);
		$user_email = $row[$mySQL_email_column[$index]];
		$user_name = $row[$mySQL_name_column[$index]];
		return TRUE;
	}

	return FALSE;
}

function LDAP_auth  ($login, $password, $index)
{
	global $LDAP_server,
		$LDAP_base_dn,
		$LDAP_userid_tag,
		$LDAP_name_tag,
		$LDAP_email_tag,
		$user_name,
		$user_email;

	if ( $password == "" )
		return FALSE;
	$ds = ldap_connect ($LDAP_server[$index]);
	if ( !$ds ) {
		echo "Errore nella connessione al server LDAP.\n</body>\n</html>\n";
		exit;
	}
	$res = ldap_bind($ds);
	if ( !$res ) {
		echo "Errore nel bind anonimo al server LDAP.\n</body>\n</html>\n";
		exit;
	}
	$sr = ldap_search ($ds, $LDAP_base_dn[$index], "$LDAP_userid_tag[$index]=$login",
				array($LDAP_userid_tag[$index], $LDAP_name_tag[$index], $LDAP_email_tag[$index]));
	if ( $sr == FALSE )
		return FALSE;
	$en = ldap_get_entries ($ds, $sr);
	for ( $i=0; $i<$en["count"]; $i++) {
		$dn = $en[$i]["dn"];
		$user_name = $en[$i][$LDAP_name_tag[$index]][0];
		$user_email = $en[$i][$LDAP_email_tag[$index]][0];
		ldap_unbind ($ds);
		//ldap_close ($ds);
		$ds = ldap_connect ($LDAP_server[$index]);
		$r = ldap_bind ($ds, $dn, $password);
		if ( $r ) {
			ldap_unbind($ds);
			ldap_close($ds);
			return TRUE;
		}
	}
	ldap_close ($ds);
	return FALSE;
}

function INTERNAL_auth ($login, $password, $index)
{
	global $INTERNAL_users,
		$user_name,
		$user_email;
	foreach ( $INTERNAL_users[$index] as $a )
		if ( $a[0] == $login && $a[1] == $password ) {
			$user_name = $a[2];
			$user_email = $a[3];
			return TRUE;
		}
	return FALSE;	
}

function SSL_auth ()
{
	global $user_name, $user_email;
	if ( getenv("SSL_CLIENT_VERIFY") == "SUCCESS" ) {
		$user_name = getenv("SSL_CLIENT_S_DN_CN");
		$user_email = getenv("SSL_CLIENT_S_DN_Email");
		return TRUE;
	}
	return FALSE;
}

function authenticate ($data)
{
	global $authentication_method;

	if ( SSL_auth() )
		return TRUE;

	$login = $data["login"];
	$password = $data["password"];
	$method = $data["method"];

	if ( $authentication_method[$method][0] == "RADIUS" )
		return RADIUS_auth ($login, $password, $authentication_method[$method][1]);
	if ( $authentication_method[$method][0] == "mySQL" )
		return mySQL_auth ($login, $password, $authentication_method[$method][1]);
	if ( $authentication_method[$method][0] == "LDAP" )
		return LDAP_auth ($login, $password, $authentication_method[$method][1]);
	if ( $authentication_method[$method][0] == "INTERNAL" )
		return INTERNAL_auth ($login, $password, $authentication_method[$method][1]);
	echo "Autenticazione $authentication_method non ancora realizzata.\n</body>\n</html>";
	exit;
}

?>
