<?php

/*
Copyright (C) 2004 NetMob Group, Universit di Trento, Italy


     http://netmob.unitn.it/


This file is part of the WilmaGate system, created as part
of the WILMA Project, sponsored by the Autonomous
Province of Trento and participated by ITC-irst, the University
of Trento and Alpikom Spa. More info at


     http://www.wilmaproject.org/


PERMISSION OF USING AND MODIFYING THE WILMAGATE SYSTEM IS GRANTED
FOR RESEARCH PURPOSES ONLY. Implementations that are not
oriented to research are prohibited unless explicitly authorized
by the NetMob research group.
Please direct all authorization requests to


     Roberto Battiti battiti@dit.unitn.it


Technical questions can be directed to


     Mauro Brunato brunato@dit.unitn.it
*/

/*******************************************
 *
 * List of proposed authentication services.
 *
 * Every service is represented by a triplet:
 *
 * - Method name (RADIUS, LDAP, mySQL, INTERNAL)
 * - Ordinal number within each method (starting from 0)
 * - Description string (in HTML).
 *
 * The user shall be presented with a list of descriptions.
 *
 */

$method_count = 0;
$authentication_method[$method_count++] = array ( "LDAP", 0,
		"Employees and collaborators" );
$authentication_method[$method_count++] = array ( "LDAP", 1,
		"Students" );
$authentication_method[$method_count++] = array ( "mySQL", 0,
		"Other authorized users" );

/***********************************************
 *
 * RADIUS configuration section
 *
 */

$RADIUS_server[0] = "localhost";
$RADIUS_port[0] = 1812;
$RADIUS_shared_secret[0] = "YesWeHaveNoBananas";
$RADIUS_welcome_id[0] = 18;

/***********************************************
 *
 * LDAP configuration section
 *
 * Two services are configured, one for employees,
 * the other for students.
 * Note that base DNs and tag names are definable,
 * and depend on the structure of the local service.
 *
 */

$LDAP_server[0] = "people.unitn.it";
$LDAP_base_dn[0] = "dc=unitn, dc=it";
$LDAP_userid_tag[0] = "uid";
$LDAP_email_tag[0] = "mail";
$LDAP_name_tag[0] = "cn";

$LDAP_server[1] = "people2.unitn.it";
$LDAP_base_dn[1] = "dc=studenti, dc=unitrento, dc=it";
$LDAP_userid_tag[1] = "uid";
$LDAP_email_tag[1] = "mail";
$LDAP_name_tag[1] = "cn";

/***********************************************
 *
 * mySQL configuration section
 *
 * The database must provide four columns: login,
 * password (MD5-hashed), full name and email.
 * Column names are free.
 *
 */

$mySQL_server[0] = "localhost";
$mySQL_user[0] = "root";
$mySQL_password[0] = "XxXxXx";
$mySQL_database[0] = "Fred";
$mySQL_table[0] = "accounts";
$mySQL_username_column[0] = "login";
$mySQL_password_column[0] = "password";
$mySQL_name_column[0] = "name";
$mySQL_email_column[0] = "email";

/***********************************************
 *
 * INTERNAL configuration section
 *
 * To be used only for tests!!
 *
 */

// Order of items is username, password, full name, email

$INTERNAL_users[0] = array (
	array ("brunato", "otanurb", "Mauro Brunato", "brunato@dit.unitn.it"),
	array ("guest", "guest", "Guest User", "nomail@nodomain")
);

?>
