<?php
/*
Copyright (C) 2004 NetMob Group, Universit di Trento, Italy


     http://netmob.unitn.it/


This file is part of the WilmaGate system, created as part
of the WILMA Project, sponsored by the Autonomous
Province of Trento and participated by ITC-irst, the University
of Trento and Alpikom Spa. More info at


     http://www.wilmaproject.org/


PERMISSION OF USING AND MODIFYING THE WILMAGATE SYSTEM IS GRANTED
FOR RESEARCH PURPOSES ONLY. Implementations that are not
oriented to research are prohibited unless explicitly authorized
by the NetMob research group.
Please direct all authorization requests to


     Roberto Battiti battiti@dit.unitn.it


Technical questions can be directed to


     Mauro Brunato brunato@dit.unitn.it
*/

function check_socket_result ($res, $s)
{
	if ( $res === FALSE ) {
		echo "Errore socket.<p>Causa probabile: il sistema &egrave; in fase di riavvio o di manutenzione.\n</body>\n</html>\n";
		fclose ($s);
		exit;
	}
}

function open_socket ($url, $port)
{
	return fsockopen ($url, $port);
}

function close_socket ($s)
{
	return fclose ($s);
}

function line_from_socket ($s)
{
	$line = fgets($s, 1024);
	for ( $i = 0; $i < strlen($line) && $line{$i} != "\r" && $line{$i} != "\n"; $i++ );
	return substr ($line, 0, $i);
}


function line_to_socket ($s, $l)
{
	return fwrite($s, $l);
}


function sendauth ($addr, $port, $token, $raddr, $problems)
{
	global $user_name, $user_email, $new_token, $next_urls, $renew_time;

	$s = open_socket ($addr, $port);
	check_socket_result ($s, $s);

	$req = "authenticate\t$raddr\t$user_name\t$user_email\t$token";
	if ( $problems )
		$req .= "\t1\n";
	else
		$req .= "\t0\n";
	$res = line_to_socket ($s, $req);
	check_socket_result ($res, $s);

	$rep = line_from_socket ($s);
	check_socket_result ($rep, $s);

	if ( strtok ($rep, "\t") != "ok" )
		$return_value = FALSE;
	else {
		$new_token = strtok ("\t");
		$renew_time = strtok ("\t");
		$return_value = TRUE;
	}

	// Complete version
	//while ( ($rep = line_from_socket($s)) != "" )
	//	$next_urls .= $rep . '!';
	//
	// For now, just take the first URL
	//
	$next_urls = line_from_socket($s) . '!';
	check_socket_result ($next_urls, $s);
	while ( line_from_socket($s) != "" );

	$res = line_to_socket ($s, "exit\n");
	check_socket_result ($res, $s);

	$res = close_socket ($s);
	check_socket_result ($res, $s);
	//apache_child_terminate ();

	return $return_value;
}


function revokeauth ($addr, $port, $token, $raddr)
{
	$s = open_socket ($addr, $port);
	check_socket_result ($s, $s);

	$req = "revoke\t$raddr\t$token\n";
	$res = line_to_socket ($s, $req);
	check_socket_result ($res, $s);

	$rep = line_from_socket ($s);
	check_socket_result ($rep, $s);

	$res = line_to_socket ($s, "exit\n");
	check_socket_result ($res, $s);

	$res = close_socket ($s);
	check_socket_result ($res, $s);

	//apache_child_terminate ();

	return (strtok ($rep, "\t") == "ok") ? TRUE : FALSE;
}


?>
