<?php

/*
Copyright (C) 2004 NetMob Group, Universit di Trento, Italy


     http://netmob.unitn.it/


This file is part of the UniFy authentication system. This system is 
built starting form the source software called WilmaGate
developed under the WILMA Project and now is maintened under 
TWELVE PRIN Project.
More info about the two projects at


     http://www.wilmaproject.org/
     http://twelve.dit.unitn.it/


PERMISSION OF USING AND MODIFYING THE UNI-FY SYSTEM IS GRANTED
FOR RESEARCH PURPOSES ONLY. Implementations that are not
oriented to research are prohibited unless explicitly authorized
by the NetMob research group.


Technical questions can be directed to


     uni-fy@dit.unitn.it
*/


Header ("Expires: 0");
Header ("Cache-Control: no-cache");
Header ("Pragma: no-cache");

function check_socket_result ($res, $s)
{
	if ( $res === FALSE ) {
		echo "Errore socket: " . socket_strerror (socket_last_error ($s))
				. "\n\n</body>\n</html>\n";
		exit;
	}
}

///
/// \brief Receive a line of text on a TCP socket.
///
/// Return the line after the first carriage return.
///
/// \param s Socket handle.
///
function line_from_socket ($s)
{
	$line = "";
	$c = "0";
	do {
		$res = socket_recv ($s, $c, 1, 0);
		check_socket_result ($res, $s);
		if ( $c != "\n" && $c != "\r" )
			$line .= $c;
	} while ( $c != "\n" );
	return $line;
}

$thisSite = "http://192.168.10.2/gate/local/";

$RPORT = array_key_exists("RPORT",$_GET) ? $_GET["RPORT"] : 54272;
$PORT = array_key_exists("PORT",$_GET) ? $_GET["PORT"] : 54273;
$laddr = $_SERVER["SERVER_ADDR"];
$gaddr = $_GET["REP"];
$aaddr = $_GET["AUTH"];
$raddr = $_GET["CLI"];
$skip = array_key_exists("SKIP",$_GET)?$_GET["SKIP"]:1;

// Retrieve providers list
$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
check_socket_result ($s, $s);
$res = socket_connect ($s, $gaddr, $RPORT);
check_socket_result ($res, $s);
$c = "providers " . $raddr . "\n";
$res = socket_write ($s, $c);
check_socket_result ($res, $s);
$token = line_from_socket ($s);
check_socket_result ($res, $s);
$providers = 0;
do {
	$firstline = line_from_socket ($s);
	if ( $firstline != "" ) {
		$name[$providers] = strtok ($firstline, "\t");
		$url[$providers++] = strtok ("\t");
	}
} while ( $firstline != "" );
$res = socket_write ($s, "exit\n");
check_socket_result ($res, $s);
socket_close ($s);

$title = "Connessione all'autenticatore / Connection to authenticator";

if ( $providers == 1 || $skip == 1 ) {
	$destination = $url[0] . "?token=" . urlencode($token)
			. "&raddr=" . urlencode($raddr) . "&laddr=" . urlencode($laddr)
			. "&gaddr=" . urlencode($aaddr)
			. "&oper=UNITN"
			. "&PORT=" . $PORT
			. "&RPORT=" . $RPORT
			. (($providers==1)?"":"&use=" . urlencode($thisSite."choose.php?REP=".$gaddr."&AUTH=".$aaddr
					."&CLI=".$raddr."&SKIP=0&PORT=".$PORT."&RPORT=".$RPORT));
	Header ("Refresh: 1; url=" . $destination);
}
?>


<html>
<head>
<title><?php echo $title;?></title>
</head>
<body>

<table cellspacing="0" cellpadding="0">
<tr align=center><td align="center" colspan=3>

<!--------------------- Common WELCOME bar begins here ---------------------------->
<table border=0 cellspacing="0" cellpadding="0" width=800 border=0 align=center>
<tr align=center><td colspan=3 align="center">
<font face="verdana" size=+2><b>
WELCOME to WLAN HotSpot of
	<!--------  Name of HotSpot  -------->
</b></font>
</td>
</tr><tr><td align=right width=260>
	<!-------- Logo of Owner  -------->
</td>
<td width=105></td>
<td align=left>
	<!-------- Logo of ManagementGroup   -------->
</td></tr>
</table>
</td>
</tr>
<!--------------------- Common WELCOME bar end here ---------------------------->

<tr>

<!--------------------- Common PATRONS bar begins here ---------------------------->
<td align=center valign=top>
	<!-------- Logo of Patron  -------->
<br>
<font face="verdana" color="#008000"><b>
	<!-------- Name of Patron  -------->
</b></font>
<hr>
	<!-------- If more than ONe patrons, please duplicate previous structure  -------->

<!---------------------- MANDATORY CREDITS ---------------------------->
<!--
Partial or complete removal or alteration of these mandatory credits
is a violation of Copyright.
-->
<a href="javascript:;" onClick="window.open('credits.html', 'credits',
'width=820, height=500, resizable, scrollbars=1');"><img src="credits.jpg" alt="[Credits]"></a>
</td>
<!---------------------- Common PATRONS bar ends here ---------------------------->

<td width=25></td>

<td valign=top>
<!---------------------- Provider choice code ---------------------------------------->

<?php
// If only one provider, redirect to it
if ( $providers == 1 || $skip == 1 ) {

?>

Se non accade nulla entro 15 secondi, <a href="<?php echo $destination;?>">premere qui</a>.<br>
<i>If nothing happens in 15 seconds, <a href="<?php echo $destination;?>">click here</a>.
</i>

<h2>Connessione a una pagina sicura di autenticazione<br>
<i>Connecting to secure authentication page</i></h2>

<b>Rispondere "S&igrave;" alla richiesta di accettazione del certificato.<br>
<b><i>Please answer "Yes" to any certificate acceptance request.</i></b>

<?php

}

// Otherwise show a list

else {

?>

<h1>Scelta dell'autenticatore</h1>

Scegli il tuo autenticatore:<br><i>Please choose your authenticator</i>:
<p align="center">

<?php
for ( $i = 0; $i < $providers; $i++ )
	echo "[<a href=\"" . $url[$i] . "?token=" . urlencode($token)
			. "&raddr=" . urlencode($raddr) . "&laddr=" . urlencode($laddr)
			. "&gaddr=" . urlencode($aaddr)
			. "&oper=WILMA\">"
			. $name[$i] . "</a>]&nbsp;\n";
?>

<hr>

<h3>Istruzioni / <i>Instructions</i></h1>

Scegliere l'autenticatore dalla lista presentata sopra. Comparir&agrave; un modulo di identificazione
da parte dell'operatore scelto.<br>
<i>Select your internet provider from the list above. You will be directed to your operator's login page.</i>
<p>
Una volta autenticati, avrete libero accesso alla rete locale.<br>
<i>Once authenticated, you will be granted access to the local network.</i>

<?php

}

?>

<!---------------------- Provider choice code ends here---------------------------------------->
</td>
</tr>

<tr><td colspan=3>

<!-------------------- Common FOOTER begins here ------------------------------------>

<!-------------------- Common FOOTER ends here ------------------------------------>

</td></tr>

</table>

</body>

</html>
