<?php

/*##############################################################################
   
   Developed by NetMob Group, University of Trento, Italy

   University of Trento
   DIT - Department of Informatics and Telecommunications 
   Computer Networks and Mobility Research Program
   http://netmob.unitn.it/ 
   
   This file is part of the WilmaGate system, created as part
   of the WILMA Project, sponsored by the Autonomous
   Province of Trento and participated by ITC-irst, the University
   of Trento and Alpikom Spa. More info at

     http://www.wilmaproject.org/		

   To download the project:
      - in tarball format
        http://netmob.unitn.it/wilmagate.html
      - connect to CVS repository
        :pserver:cvs@rtm.unitn.it:/home/cvsroot
   In both previous cases, the download is password protected. To obtain
   the password you must send a mail to 

      wilmagate@dit.unitn.it

################################################################################

   The WilmaGate Licence of Use


   Copyright (c) 2003-2005
                - Universita` di Trento,
                  Dipartimento di Informatica e Telecomunicazioni (DIT)
                  Computer Networks and Mobility Research Program


   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (hereinafter
   the "WilmaGate") directly from the copyright owner, to use the WilmaGate
   without restriction of purpose or time, including without limitation the
   rights to use, copy, modify, and merge the WilmaGate, subject to the
   following conditions:

   The above copyright notice and this permission notice shall be included
   in all copies or substantial portions of the WilmaGate. 

   The WilmaGate shall not be sub-licenced either commercially or free of
   charge, as is or in part or as a part of any other package. 

   The licensee agrees to properly credit WilmaGate and its copyright 
   owners in any technical, scientific or divulgative publication, 
   whatever publishing means are used, that is based entirely or in part 
   on WilmaGate use, as well as in any booklet, web-site or brochure that 
   advertise services based on WilmaGate use. 

   If the WilmaGate is modified, the copyright owner shall be notified.

   THE WilmaGate IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

##############################################################################*/

Header ("Expires: 0");
Header ("Cache-Control: no-cache");
Header ("Pragma: no-cache");
Header ("Refresh: 60");

include "definitions.inc.php";

function check_socket_result ($res, $s)
{
	if ( $res === FALSE ) {
		echo "Errore socket: " . socket_strerror (socket_last_error ($s))
				. "\n\n</body>\n</html>\n";
		exit;
	}
}

function line_from_socket ($s)
{
	$line = "";
	$c = "0";
	do {
		$res = socket_recv ($s, $c, 1, 0);
		check_socket_result ($res, $s);
		if ( $c != "\n" && $c != "\r" )
			$line .= $c;
	} while ( $c != "\n" );
	return $line;
}



function tempo ($sec)
{
	if ( $sec <= 0 )
		return "Time out.";
	$secondi = $sec % 60;
	$sec /= 60;
	$minuti = $sec % 60;
	$sec /= 60;
	return ($sec > 1000) ? "Static assignment" : ((int)$sec . "h" . $minuti . "'" . $secondi . '"');
}

$ip = $_GET["IP"];
?>

<html>
<head>
<title>UniFy: Client Status <?php echo $ip;?></title>
</head>

<body>

<h1>UniFy: Client Status <?php echo $ip;?></h1>

<?php
$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
check_socket_result ($s, $s);
$res = socket_connect ($s, $server_ip, $server_port);
check_socket_result ($res, $s);
$c = "detail " . $ip . "\n";
$res = socket_write ($s, $c);
check_socket_result ($res, $s);

$line = line_from_socket ($s);
$result = strtok ($line, "\t");

$res = socket_write ($s, "exit\n");
check_socket_result ($res, $s);

$res = socket_close ($s);
check_socket_result ($res, $s);

//echo "\n<pre>\n$line\n</pre>\n";

if ( $result != "OK" ) {

?>

Client's IP not in Gatekeeper's table.

<?php

}
else {

	$tempo = strtok("\t");
	$stato = strtok ("\t");
	$utente = strtok ("\t");
	$email = strtok ("\t");
	$fineIP = strtok ("\t");
	$fineAUT = strtok ("\t");
	
	if( $stato > 1)
	{
		echo "<p><a href=\"index2.php\">Search Again</a><br>";
		echo "<h2>Results:</h2>";
		echo "<table align=left>";
		if ( $stato > 2 ) {
			echo "<tr><td align=\"right\">IP lease timeout:</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . tempo($fineIP-$tempo) . "</tt></td>\n";
	
			if ( $stato >= 4 ) {
				echo "<tr><td align=\"right\">User ID</td><td width=10px> </td>";
				echo "<td align=\"right\"><tt>" . htmlentities($utente) . "</tt></td>\n";
				echo "<tr><td align=\"right\">Mail</td><td width=10px> </td>";
				echo "<td align=\"right\"><tt>" . htmlentities($email) . "</tt></td>\n";
				echo "<tr><td align=\"right\">Auth. TimeOut</td><td width=10px> </td>";
				echo "<td align=\"right\"><tt>" . tempo($fineAUT-$tempo) . "</tt></td>\n";
			}
		}
	}
}
?>

</body>

</html>
