<?php

/*##############################################################################
   
   Developed by NetMob Group, University of Trento, Italy

   University of Trento
   DIT - Department of Informatics and Telecommunications 
   Computer Networks and Mobility Research Program
   http://netmob.unitn.it/ 
   
   This file is part of the WilmaGate system, created as part
   of the WILMA Project, sponsored by the Autonomous
   Province of Trento and participated by ITC-irst, the University
   of Trento and Alpikom Spa. More info at

     http://www.wilmaproject.org/		

   To download the project:
      - in tarball format
        http://netmob.unitn.it/wilmagate.html
      - connect to CVS repository
        :pserver:cvs@rtm.unitn.it:/home/cvsroot
   In both previous cases, the download is password protected. To obtain
   the password you must send a mail to 

      wilmagate@dit.unitn.it

################################################################################

   The WilmaGate Licence of Use


   Copyright (c) 2003-2005
                - Universita` di Trento,
                  Dipartimento di Informatica e Telecomunicazioni (DIT)
                  Computer Networks and Mobility Research Program


   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (hereinafter
   the "WilmaGate") directly from the copyright owner, to use the WilmaGate
   without restriction of purpose or time, including without limitation the
   rights to use, copy, modify, and merge the WilmaGate, subject to the
   following conditions:

   The above copyright notice and this permission notice shall be included
   in all copies or substantial portions of the WilmaGate. 

   The WilmaGate shall not be sub-licenced either commercially or free of
   charge, as is or in part or as a part of any other package. 

   The licensee agrees to properly credit WilmaGate and its copyright 
   owners in any technical, scientific or divulgative publication, 
   whatever publishing means are used, that is based entirely or in part 
   on WilmaGate use, as well as in any booklet, web-site or brochure that 
   advertise services based on WilmaGate use. 

   If the WilmaGate is modified, the copyright owner shall be notified.

   THE WilmaGate IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

##############################################################################*/



Header ("Expires: 0");
Header ("Cache-Control: no-cache");
Header ("Pragma: no-cache");
Header ("Refresh: 60");

include "definitions.inc.php";

function check_socket_result ($res, $s)
{
	if ( $res === FALSE ) {
		echo "Errore socket: " . socket_strerror (socket_last_error ($s))
				. "\n\n</body>\n</html>\n";
		exit;
	}
}

function line_from_socket ($s)
{
	$line = "";
	$c = "0";
	do {
		$res = socket_recv ($s, $c, 1, 0);
		check_socket_result ($res, $s);
		if ( $c != "\n" && $c != "\r" )
			$line .= $c;
	} while ( $c != "\n" );
	return $line;
}


function tempo ($sec)
{
	if ( $sec <= 0 )
		return "Time out.";
	$secondi = $sec % 60;
	$sec /= 60;
	$minuti = $sec % 60;
	$sec /= 60;
	return ($sec > 1000) ? "Static assignment" : ((int)$sec . "h" . $minuti . "'" . $secondi . '"');
}

//------------------------------------------------------------------
// Find MAC
if(isset($_GET["mac-form"]))
{
	$mac=$_GET["mac"];
	
	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, $server_ip, $server_port);
	check_socket_result ($res, $s);
	$c = "list 1\n";
	$res = socket_write ($s, $c);
	check_socket_result ($res, $s);
	$found=0;
	echo "<HTML>\n<HEAD>\n<TITLE>Search Engine</TITLE>\n</HEAD>\n<BODY>\n";
	echo "<p><a href=\"index2.php\">Search Again</a><br><br>";
	echo "<h2>Results:</h2>";
	echo "<table align=left>";
	$i=0;
	do {
		$line = line_from_socket ($s);
	        if ( $line == "" )
			break;
		$ip = strtok ($line, "\t");
		$ethernet = strtok ("\t");
		$stato = strtok ("\t");
		$list_user[$i][0]=$ip;
		$list_user[$i][1]=$ethernet;
		$list_user[$i][2]=$stato;
		$i=$i+1;
	} while ( $line != "" );
	
	for($j=0, $found=0 ; $j<$i ; $j=$j+1)
	{
		if(stristr($list_user[$j][1], $mac) && $list_user[$j][2] > 1)
		{
			$c = "detail " . $list_user[$j][0] . "\n";
			$res = socket_write ($s, $c);
			check_socket_result ($res, $s);
			$line = line_from_socket ($s);
			$result = strtok ($line, "\t");
			
			$tempo = strtok("\t");
			$stato = strtok ("\t");
			$utente = strtok ("\t");
			$email = strtok ("\t");
			$fineIP = strtok ("\t");
			$fineAUT = strtok ("\t");

			echo "<tr><td align=\"right\">IP Address</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $list_user[$j][0] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">MAC Adddress</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $list_user[$j][1] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Status</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $statusname[$list_user[$j][2]] . "</tt></td></tr>\n";

			if ( $list_user[$j][2] > 2 ) {
				echo "<tr><td align=\"right\">IP lease timeout:</td><td width=10px> </td>";
				echo "<td align=\"right\"><tt>" . tempo($fineIP-$tempo) . "</tt></td>\n";
				if ( $list_user[$j][2] >= 4 ) {
					echo "<tr><td align=\"right\">User ID</td><td width=10px> </td>";
					echo "<td align=\"right\"><tt>" . htmlentities($utente) . "</tt></td>\n";
					echo "<tr><td align=\"right\">Mail</td><td width=10px> </td>";
					echo "<td align=\"right\"><tt>" . htmlentities($email) . "</tt></td>\n";
					echo "<tr><td align=\"right\">Auth. TimeOut</td><td width=10px> </td>";
					echo "<td align=\"right\"><tt>" . tempo($fineAUT-$tempo) . "</tt></td>\n";
				}
			}
			echo "<tr><td colspan=3 align=center><br><hr width=80%><br></td></tr>\n";
			$found=1;
		}
	}
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	$res = socket_close ($s);
	check_socket_result ($res, $s);

	if(!$found)
	{
		echo "<tr><td>No found elements.</td></tr>\n";
	}
	echo "</table>\n<br><br></BODY></HTML>";
	echo "</table>\n<br><br></BODY></HTML>";			
	
}
// End Find MAC
//------------------------------------------------------------------

else //else1
{	
//------------------------------------------------------------------
// Find USERNAME
if(isset($_GET["username-form"]))
{
	$username=$_GET["username"];
	
	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, $server_ip, $server_port);
	check_socket_result ($res, $s);
	$c = "list 1\n";
	$res = socket_write ($s, $c);
	check_socket_result ($res, $s);
	$found=0;
	echo "<HTML>\n<HEAD>\n<TITLE>Search Engine</TITLE>\n</HEAD>\n<BODY>\n";
	echo "<p><a href=\"index2.php\">Search Again</a><br><br>";
	echo "<h2>Results:</h2>";
	echo "<table align=left>";
	$i=0;
	do {
		$line = line_from_socket ($s);
	        if ( $line == "" )
			break;
		$ip = strtok ($line, "\t");
		$ethernet = strtok ("\t");
		$stato = strtok ("\t");
		$list_user[$i][0]=$ip;
		$list_user[$i][1]=$ethernet;
		$list_user[$i][2]=$stato;
		$i=$i+1;
	} while ( $line != "" );
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	socket_close ($s);			
	
	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, "193.205.213.40", 54272);
	check_socket_result ($res, $s);

	for($j=0, $found=0 ; $j<$i ; $j=$j+1)
	{
		$c = "detail " . $list_user[$j][0] . "\n";
		$res = socket_write ($s, $c);
		check_socket_result ($res, $s);
		$line = line_from_socket ($s);
		$result = strtok ($line, "\t");
			
		$tempo = strtok("\t");
		$stato = strtok ("\t");
		$utente = strtok ("\t");
		$email = strtok ("\t");
		$fineIP = strtok ("\t");
		$fineAUT = strtok ("\t");
			
		if(stristr($utente, $username) && $list_user[$j][2] >= 4)
		{
			echo "<tr><td align=\"right\">IP Address</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $list_user[$j][0] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">MAC Adddress</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $list_user[$j][1] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Status</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $statusname[$list_user[$j][2]] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">IP lease timeout:</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . tempo($fineIP-$tempo) . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">User ID</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . htmlentities($utente) . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Mail</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . htmlentities($email) . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Auth. TimeOut</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . tempo($fineAUT-$tempo) . "</tt></td></tr>\n";
			echo "<tr><td colspan=3 align=center><br><hr width=80%><br></td></tr>\n";
			$found=1;			
		}
	}
	
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	$res = socket_close ($s);
	check_socket_result ($res, $s);

	if(!$found)
	{
		echo "<tr><td>No found elements.</td></tr>\n";
	}
	echo "</table>\n<br><br></BODY></HTML>";	

}
// End Find MAC
//------------------------------------------------------------------

else //else2
{
//------------------------------------------------------------------
// Find MAIL
if(isset($_GET["mail-form"]))
{
	$reqmail=$_GET["mail"];
	
	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, $server_ip, $server_port);
	check_socket_result ($res, $s);
	$c = "list 1\n";
	$res = socket_write ($s, $c);
	check_socket_result ($res, $s);
	$found=0;
	echo "<HTML>\n<HEAD>\n<TITLE>Search Engine</TITLE>\n</HEAD>\n<BODY>\n";
	echo "<p><a href=\"index2.php\">Search Again</a><br><br>";
	echo "<h2>Results:</h2>";
	echo "<table align=left>";
	$i=0;
	do {
		$line = line_from_socket ($s);
	        if ( $line == "" )
			break;
		$ip = strtok ($line, "\t");
		$ethernet = strtok ("\t");
		$stato = strtok ("\t");
		$list_user[$i][0]=$ip;
		$list_user[$i][1]=$ethernet;
		$list_user[$i][2]=$stato;
		$i=$i+1;
	} while ( $line != "" );
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	socket_close ($s);			
	
	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, "193.205.213.40", 54272);
	check_socket_result ($res, $s);

	for($j=0, $found=0 ; $j<$i ; $j=$j+1)
	{
		$c = "detail " . $list_user[$j][0] . "\n";
		$res = socket_write ($s, $c);
		check_socket_result ($res, $s);
		$line = line_from_socket ($s);
		$result = strtok ($line, "\t");
			
		$tempo = strtok("\t");
		$stato = strtok ("\t");
		$utente = strtok ("\t");
		$email = strtok ("\t");
		$fineIP = strtok ("\t");
		$fineAUT = strtok ("\t");
			
		if(stristr($email, $reqmail) && $list_user[$j][2] >= 4)
		{
			echo "<tr><td align=\"right\">IP Address</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $list_user[$j][0] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">MAC Adddress</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $list_user[$j][1] . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Status</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . $statusname[$list_user[$j][2]] . "</tt></td></tr>\n";

			echo "<tr><td align=\"right\">IP lease timeout:</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . tempo($fineIP-$tempo) . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">User ID</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . htmlentities($utente) . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Mail</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . htmlentities($email) . "</tt></td></tr>\n";
			echo "<tr><td align=\"right\">Auth. TimeOut</td><td width=10px> </td>";
			echo "<td align=\"right\"><tt>" . tempo($fineAUT-$tempo) . "</tt></td></tr>\n";
			echo "<tr><td colspan=3 align=center><br><hr width=80%><br></td></tr>\n";
			$found=1;			
		}
	}
	
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	$res = socket_close ($s);
	check_socket_result ($res, $s);

	if(!$found)
	{
		echo "<tr><td>No found elements.</td></tr>\n";
	}
	echo "</table>\n<br><br></BODY></HTML>";
}
// End Find MAIL
//------------------------------------------------------------------

else //else3
{
//------------------------------------------------------------------
// Find IPRANGE
if(isset($_GET["rangeip-form"]))
{
	$fromip=$_GET["fromip"];
	$toip=$_GET["toip"];

	if(strnatcmp($fromip, $ip_starting)<0)
		$fromip = $ip_starting;
	if(strnatcmp($toip, $ip_ending) >0)
		$toip = $ip_ending;

	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, $server_ip, $server_port);
	check_socket_result ($res, $s);
	$c = "list 1\n";
	$res = socket_write ($s, $c);
	check_socket_result ($res, $s);
	echo "<HTML>\n<HEAD>\n<TITLE>Search Engine</TITLE>\n</HEAD>\n<BODY>\n";
	echo "<p><a href=\"index2.php\">Search Again</a><br><br>";
	echo "<h2>Results:</h2>";
	echo "<table align=left cellpadding=1 border=1>\n<tr><th>IP</th><th>Ethernet</th><th>Status</th></tr>";
	do {
		$line = line_from_socket ($s);
		if ( $line == "" )
			break;
		$ip = strtok ($line, "\t");
		$ethernet = strtok ("\t");
		$stato = strtok ("\t");
		if ( $stato <= 1 )
			continue;
		if (strnatcmp($ip, $fromip)>0 && strnatcmp($ip, $toip)<0) //$ip >= $fromip && $ip <= $toip )
		{
			echo "<tr><td align=\"right\"><tt><a href=\"client2.php?IP=" . $ip . "\">" . $ip . "</a></tt></td>\n";
			echo "<td><tt>" . (($stato>1)?$ethernet:"---") . "</tt></td>";
			echo "<td>" . $statusname[$stato] . "</td></tr>\n";
		}
	} while ( $line != "" );	

	
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	$res = socket_close ($s);
	check_socket_result ($res, $s);

	echo "</table>\n<br><br></BODY></HTML>";
}
// End Find IPRANGE
//------------------------------------------------------------------

else //else4
{
//------------------------------------------------------------------
// Show ALL
if(isset($_GET["showall-form"]))
{
	$s = socket_create (AF_INET, SOCK_STREAM, SOL_TCP);
	check_socket_result ($s, $s);
	$res = socket_connect ($s, $server_ip, $server_port);
	check_socket_result ($res, $s);
	$c = "list 1\n";
	$res = socket_write ($s, $c);
	check_socket_result ($res, $s);
	echo "<HTML>\n<HEAD>\n<TITLE>Search Engine</TITLE>\n</HEAD>\n<BODY>\n";
	echo "<p><a href=\"index2.php\">Search Again</a><br><br>";
	echo "<h2>Results:</h2>";
	echo "<table align=left cellpadding=1 border=1>\n<tr><th>IP</th><th>Ethernet</th><th>Status</th></tr>";
	do {
		$line = line_from_socket ($s);
		if ( $line == "" )
			break;
		$ip = strtok ($line, "\t");
		$ethernet = strtok ("\t");
		$stato = strtok ("\t");
		if ( $stato <= 1 )
			continue;
		if (strnatcmp($ip, $ip_starting)>0 && strnatcmp($ip, $ip_ending)<0) //$ip >= $fromip && $ip <= $toip )
		{
			echo "<tr><td align=\"right\"><tt><a href=\"client2.php?IP=" . $ip . "\">" . $ip . "</a></tt></td>\n";
			echo "<td><tt>" . (($stato>1)?$ethernet:"---") . "</tt></td>";
			echo "<td>" . $statusname[$stato] . "</td></tr>\n";
		}
	} while ( $line != "" );	

	
	$res = socket_write ($s, "exit\n");
	check_socket_result ($res, $s);
	$res = socket_close ($s);
	check_socket_result ($res, $s);

	echo "</table>\n<br><br></BODY></HTML>";
}
// End Show ALL
//------------------------------------------------------------------

else //else5
{
//------------------------------------------------------------------
// SHOW FORM
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<title>UniFy Client Status</title>
		<meta name="author" content="Danilo" >
		<meta name="generator" content="screem 0.16.1" >
		<meta name="description" content="" >
		<meta name="keywords" content="" >
		<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" >
	</head>
	<body>

<table width="40%" align="center" border="0">
<tr><td colspan=2><h1>UniFy Research Engine</h1><BR><BR></td></tr>
<tr><td>Mac Address</td><td>
	<form method="GET" action="index2.php">
	<input name="mac">&nbsp;&nbsp;
	<button name="mac-form">OK</button>
	</form>
</td></tr>
<tr><td colspan="2"><hr></td></tr>
<tr><td>User Name</td><td>
	<form method="GET" action="index2.php">
	<input name="username">&nbsp;&nbsp;
	<button name="username-form">OK</button>
	</form>
</td></tr>
<tr><td colspan="2"><hr></td></tr>
<tr><td>Mail Address</td><td>
	<form method="GET" action="index2.php">
	<input name="mail">&nbsp;&nbsp;
	<button name="mail-form" value="1">OK</button>
	</form>
</td></tr>
<tr><td colspan="2"><hr></td></tr>
<tr><td><table width="100%" border="0">
	<tr><td>From IP<br><br>To IP</td></tr></table>
</td><td><table width="100%" border="0"><tr><td>
	<form method="GET" action="index2.php">
	<input name="fromip"><br><br>
	<input name="toip">&nbsp;&nbsp;
	<button name="rangeip-form">OK</button></td></tr></table>
	</form>
</td></tr>
<tr><td colspan="2"><hr></td></tr>
<tr><td>Show All</td><td>
	<form method="GET" action="index2.php">
	<button name="showall-form">OK</button>
	</form>
</td></tr>
</table>

	</body>
</html>

<?
// End SHOW FORM
//------------------------------------------------------------------
} //endl else5
} //endl else4
} //endl else3
} //endl else2
} //endl else1


?>

